;
; SETENV v1.11 Copyright (C) 06/1996-04/1997 by Matthias Paul
;                                               Ubierstrae 28
;                                               D-50321 BRHL
;                                               GERMANY
;
; SETENV is FreeWare, not Public Domain!  All rights reserved!
;
; The source code is provided with the intention, that some people might
; want to get some background on CONFIG.SYS pre-environment implementation
; details.  Also, here you can find bimodal .COM/.SYS driver techniques,
; a sophisticated ANSI-driver detection method, and other interesting things.
;
; If parts of my sources or features (e.g. INSTALL= /Z and /D, see docs)
; will become part of other utilities, or will be included in future DOS
; operating systems, as a reference to the original inventor and implementor
; of these SETENV.COM features, my name must be mentioned in these sources.
; Also, I would like to get a free copy of any of these products.
;
; For global maintainment of SETENV, please report all errors or
; modifications to me, rather than distributing modified versions
; of the software.
;
; EMail: <Matthias.Paul@post.rwth-aachen.de>
;
; Last edit: 1997-05-24 -mp
;
; Notes:
;
; - SETENV hides/discovers the CONFIG.SYS pre-environment established by
;   DR DOS 6.0, Novell DOS 7, and Caldera OpenDOS and thus allows to save
;   memory when loading TSRs in CONFIG.SYS by using INSTALL=/INSTALLHIGH=/
;   HIINSTALL= etc.
; - SETENV is not a resident tool!  It toggles the current state each time
;   it is called.
; - SETENV itself is a bimodal utility, containing both, a device driver
;   header and a normal .COM program.  Thus, it can be called by
;   DEVICE= etc. or INSTALL= etc. and functions equal in both modes
;   (except for the different errorlevels).
; - SETENV v1.01+ is SETVER.EXE/SETDRVER.COM/FREEVER.COM aware.
; - Due to dual-header technics, McAfee VirusScan SCAN V2.5.1e (08/1996)
;   reported SETENV.COM older than V1.07 to be infected by a "COM2S"-virus.
;   This definitely has been a false alarm!!!  SETENV.COM's entry code
;   sequence (COMEntry) has been slightly changed to avoid this.
; - SETENV has an emergency breakout feature by pressing <Shift>+<Ctrl>+<Alt>.
; - While at least some version of DR and CCI Multiuser DOS are known to also
;   support a CCONFIG.INI SET= directive, they do not provide the single-user
;   internal variable table and there is no known way to obtain a pointer to
;   the pre-environment under these OS'es.  Hence I had to cut them off...
;   Note, that future versions of Multiuser DOS or IMS REAL/32 are not
;   being disabled in general!  SETENV tries to run on all BDOS kernels
;   equal/higher 71h (113d) - currently still not reached by the
;   IMS REAL/32 7.6 multiuser family as of 02/1997 - no matter of a single-
;   or multiuser nature, but still does some more validation checks, that
;   would certainly cut them off, if they actually won't support the
;   single-user INTVARS structure.
;
; History:
;
; Version         Date:             Author:            Changes:
;
; v1.00 - v1.10   06/1996-02/1997   by Matthias Paul   not recorded
; v1.11           1997-04-01 -      by Matthias Paul   changes in messages
;                 1997-05-24
;
; How to create SETENV.COM:
;                                 or
;  TASM /M2 SETENV;                             MASM SETENV.ASM
;  TLINK SETENV; (option /T will not work!)     LINK SETENV.OBJ
;  EXE2BIN SETENV.EXE SETENV.COM                EXE2BIN SETENV.EXE SETENV.COM
;
; Errorlevel when called as .COM program:
;
;     0 = old DOS 1.0
;     1 = pre-environment recovered or pre-environment empty
;     2 = pre-environment hidden
;   250 = break signaled by emergency breakout hotkey <Shift>+<Ctrl>+<Alt>
;   251 = pre-environment full
;   252 = command processor already loaded
;   253 = no pre-environment available
;   254 = unknown DR DOS version
;   255 = wrong DOS (MS-DOS/PC-DOS)
;
; Errorlevel when called as .SYS device driver:
;
;     0 = after init
; 32771 = later
;
; ToDo: - Command line parameters
;       - If a parameter "env=val" is given, on matching environment
;         variables SETENV should return with some special returncodes.
;         This would allow for the testage of environment variables in
;         CONFIG.SYS, using errorlevels.
;       - Means to save/restore the pre-environment pointer in INTVARS, so
;         that the pre-environment can be reenabled even after Novell's or
;         Caldera's COMMAND.COM has been used temporary in CONFIG.SYS.
;       - Maybe, added support for MS-DOS/PC-DOS 6.0+ pre-environment, which
;         is implemented completely different...
;       - Added support for normal environment (in AUTOEXEC.BAT).  The
;         problem is, that for an external utility there is no absolutely
;         fool-proof method to get a pointer to the master environment
;         under all circumstances.  But maybe this is not always necessary...


OBSOLETE              EQU 0                        ; for inclusion of old &
                                                   ; obsolete DR DOS version call

; Macros:                                          ;

Jmps MACRO address                                 ;
JMP SHORT address                                  ;
ENDM                                               ;

Rtn MACRO                                          ;
DB 0C3h                                            ;
ENDM                                               ;

; Equates:                                         ;

Version_Msg           EQU <"1.11">                 ;
Date_Msg              EQU <"970524">               ; in Japanese format!

Jfs                   EQU JNZ                      ; Jump on flags set (for TEST)
Jnfs                  EQU JZ                       ; Jump on flags not set (for TEST)
NOPInstr              EQU 90h                      ;
JMPInstr              EQU 0E9h                     ;

DWO                   EQU DWORD PTR                ;
WO                    EQU WORD PTR                 ;
BY                    EQU BYTE PTR                 ;

BS                    EQU 08h                      ;
LF                    EQU 0Ah                      ;
CR                    EQU 0Dh                      ;
CtrlZ                 EQU 1Ah                      ;
ESC_                  EQU 1Bh                      ;
SPACE                 EQU 20h                      ;
LTERM                 EQU 24h                      ;

ANSINorm              EQU <"0">                    ;
ANSIHigh              EQU <"1;">                   ;
ANSIBlack             EQU <"30">                   ;
ANSIRed               EQU <"31">                   ;
ANSIBrown             EQU <"33">                   ;
ANSIWhite             EQU <"37">                   ;
ANSIBlackH            EQU <"40">                   ;

ID                    EQU 504Dh                    ; 'MP'
MaxEnvLen             EQU 7FFFh-10h                ; maximum size of pre-env
ErrorStatus           EQU 8103h                    ; 'function not defined'
InitStatus            EQU 0100h                    ; 'error during init'

Code SEGMENT
                      ASSUME CS:Code, DS:Code
ORG 0h                                             ; assumptions for .SYS style

SETENV:               JMP COMEntry                 ; patched area if loaded as
                      DB 0FFh                      ; device driver!!!
                      DW 8000h                     ; char-device driver
                      DW OFFSET StrategyEntry      ;
                      DW OFFSET InterruptEntry     ;
                      DB "MPSETENV"                ; device driver name

                      ; #######################################################

                      DB 19 DUP(BS)
                      DB 19 DUP(SPACE)
                      DB CR, LF
                      DB "This is an executable file! Read instructions in SETENV.DOC for details!", CR, LF
                      DB "This version is FreeWare. No warranties! Use at your own risk!", CR, LF
                      DB "NaMe SeRvIcE=Utility to hide DR DOS 6.0, Novell DOS 7, Caldera OpenDOS pre-environment.", 0, CR, LF
                      DB "VeRsIoN=", Version_Msg, " (", Date_Msg, ")", 0, CR, LF
                      DB "CoPyRiGhT=SETENV (C) 1996-1997 by Matthias Paul", 0, CR, LF
                      DB "<Matthias.Paul@post.rwth-aachen.de>", 0, CR, LF
                      DB 1Ah, LTERM

RequestHeader_Ofs:    DW 0000h                     ;
RequestHeader_Seg:    DW 0000h                     ;

                      ; #######################################################

COMEntry:             MOV  AX, CS                  ; how to have both .COM and .SYS
                                                   ; .SYS driver in one file...
                      CMP  AX, 0FFF0h              ; McAfee's SCAN V2.5.1e (08/1996)
                      JAE  OldExit                 ; reported a false "COM2S" virus
                                                   ; alarm here, so I had to insert
                      ADD  AX, 10h                 ; some dummy instructions here
                                                   ; to avoid this...
                      PUSH AX                      ; add 10h to current code segment, push it
                      MOV  AX, OFFSET CS_Aligned   ; push label for alignment also
                      PUSH AX                      ; (no adjusting!)
                      RETF                         ; this RETF jumps to CS_Aligned
CS_Aligned:           PUSH CS                      ; align DS
                      POP  DS                      ;
                      CALL Start                   ; call main code
                      CMP  AH, 02h                 ; AH >= 02 -> not DOS 1.0
                      JB   OldExit                 ; AL contains errorlevel
TerminateDOS2:        MOV  AH, 4Ch                 ; terminate .COM program
                      INT  21h                     ;
                                                   ; (should never come here)
OldExit:              XOR  AX, AX                  ; terminate .COM program
                      INT  21h                     ;
                      INT  20h                     ; (should never come here)
                      Rtn                          ;

StrategyEntry:        ; this is NOPed out after first call to Strategy!!!
                      CMP  BY CS:SETENV, JMPInstr  ;
                      JNE  EndOfPatch              ;
                      CMP  WO CS:(SETENV+1), OFFSET COMEntry
                      JNE  EndOfPatch              ;
                      MOV  BY CS:SETENV, 0FFh; patch original signature
                      MOV  WO CS:(SETENV+1), 0FFFFh;

                      ;                            ;
EndOfPatch:           MOV  WO CS:RequestHeader_Seg, ES
                      MOV  WO CS:RequestHeader_Ofs, BX
                                                   ;
                      PUSHF                        ;
                      PUSH ES                      ; store ES
                      PUSH CS                      ; align extra segment
                      POP  ES                      ;
                      MOV  DI, OFFSET StrategyEntry;
                      MOV  CX, EndOfPatch-StrategyEntry
                      MOV  AL, NOPInstr            ;
                      CLD                          ; count up
                      REP  STOSB                   ; NOP out above instructions
                      POP  ES                      ; restore ES
                      POPF                         ;
                      RETF                         ;

InterruptEntry:       PUSHF                        ; store all registers used
                      PUSH AX                      ;
                      PUSH BX                      ;
                      PUSH DS                      ;
                      PUSH ES                      ;
                      LES  BX, DWO CS:RequestHeader_Ofs; ES:BX -> RequestHeader
                      CMP  BY ES:[BX], 5           ; size ok?
                      JB   ErrorExit               ;
                      MOV  AL, BY ES:[BX+02h]      ; get function number
                      CMP  AL, 0                   ;
                      JE   DriverInit              ;
                      MOV  AX, ErrorStatus         ;
DriverExit:           MOV  WO ES:[BX+03h], AX      ;
ErrorExit:
                      POP  ES                      ; restore all registers
                      POP  DS                      ;
                      POP  BX                      ;
                      POP  AX                      ;
                      POPF                         ;
                      RETF                         ;

DriverInit:           CMP  BY ES:[BX], 16h         ; size ok?
                      JB   ErrorExit               ;
                      PUSH ES                      ;
                      PUSH BX                      ;
                      PUSH CX                      ;
                      PUSH DX                      ;
                      PUSH DI                      ;
                      PUSH SI                      ;

                      CALL Start                   ; call main code

                      POP  SI                      ;
                      POP  DI                      ;
                      POP  DX                      ;
                      POP  CX                      ;
                      POP  BX                      ;
                      POP  ES                      ;
                      MOV  WO ES:[BX+0Eh], 0000h   ; set driver size to zero
                      PUSH CS                      ;
                      POP  AX                      ;
                      MOV  WO ES:[BX+10h], AX      ;
                      MOV  AX, InitStatus          ; set return status
                      Jmps DriverExit              ;

                      ; #######################################################

Start:                CALL CheckANSI               ;
                      JNE  SkipANSI                ; open gate for ANSI
                      MOV  BY CS:DisplayANSISeq, NOPInstr

SkipANSI:             MOV  DX, OFFSET Title_Msg    ; output startup message
                      CALL DisplayTitle            ;
                      MOV  DX, OFFSET Startup_Msg  ; output startup message
                      CALL DisplayMsg              ;

                      MOV  AX, 3000h               ; Get DOS version
                      XOR  BX, BX                  ;
                      XOR  DX, DX                  ;
                      INT  21h                     ;
                      OR   AL, AL                  ; DOS 1.0? -> OldDOS
                      Jnfs OldDOS                  ;
                      CMP  AL, 05h                 ;
                      JAE  DOS5                    ;
                      CMP  AL, 03h                 ; below DOS 3.31? -> WrongDOS
                      JB   WrongDOS                ;
                      JNE  DOS5                    ;
                      CMP  AH, 1Fh                 ; DOS 3.31?
                      JNE  WrongDOS                ;
                      Jmps DOS6                    ; COMPAQ 3.31 or DR DOS

OldDOS:               MOV  DX, OFFSET WrongDOS_Msg ; output startup message
                      CALL DisplayError            ;
                      XOR  AX, AX                  ;
                      Rtn                          ;

DOS5:                 CMP  AL, 06h                 ;
                      JB   DOS6                    ; get true DOS version
                      MOV  BX, AX                  ; assume defaults and get
                      MOV  AX, 3306h               ; rid of CBIS network function
                      XOR  DX, DX                  ;
                      CLC                          ;
                      INT  21h                     ;
                      JNC  SkipDRDOSBug            ;
                      CMP  AX, 0001h               ; DR DOS 5.0/6.0 return:
                      JE   DOS6                    ; invalid function
SkipDRDOSBug:         CMP  AL, 0FFh                ; (DR DOS 6.0 should never
                      JE   WrongDOS                ; come here...)
                      CMP  BL, 05h                 ; <5.xx?
                      JB   DOS6                    ; don't use that value
                      CMP  BH, 64h                 ; >x.100?
                      JAE  DOS6                    ; don't use that value
                      CMP  BL, 06h                 ;
                      JB   WrongDOS                ;

DOS6:                 CALL CheckBreakOut           ;
                      JAE  BreakOut_               ;

                      MOV  AX, 4452h               ;
                      STC                          ;
                      INT  21h                     ; Get DR DOS single user version
                      JC   test_multiuser          ;
                      Jmps test_singleuser         ;

BreakOut_:            Jmp  BreakOut

WrongDOS:             MOV  DX, OFFSET WrongDOS_Msg ; output startup message
                      CALL DisplayError            ;
                      MOV  AX, 02FFh               ; errorlevel 255
                      Rtn                          ;

test_multiuser:       MOV  AX, 4451h               ;
                      INT  21h                     ;
                      JNC  test_singleuser         ;
IF OBSOLETE
                      MOV  AX, 4412h               ; old obsolete call
                      XOR  BX, BX                  ;
                      INT  21h                     ;
ENDIF
                      JC   WrongDOS                ;
test_singleuser:      CMP  AX, 1067h               ; DR DOS 6.0?
                      JE   DOSok                   ;
                      CMP  AX, 1070h               ;
                      JNE  NotPalmDOS              ;
                      MOV  DX, OFFSET UntestedDRDOS_Msg
                      CALL DisplayHint             ;
                      Jmps DOSok                   ;
NotPalmDOS:           CMP  AL, 71h                 ; any Novell DOS 7, Caldera
                      JB   WrongDOS                ; OpenDOS 7.01, and higher;
                      CMP  AH, 10h                 ; also DR DOS 6.0 business update
                      JE   DOSok                   ;
                      CMP  AH, 14h                 ;
                      JNE  UnknownDRDOS            ;
DOSok:                MOV  CX, AX                  ; save CX
                      MOV  AX, 4458h               ; pointer to DR DOS/Novell DOS/Caldera OpenDOS
                      INT  21h                     ; internal variable table ES:BX
                      CMP  AX, 0A56h               ; DR DOS 6.0
                      JE   DRDOSok                 ;
                      CMP  AX, 0FE4h               ; Novell DOS 7 and Caldera OpenDOS 7.01
                      JE   DRDOSok                 ;
                      Jmps UnknownDRDOS            ;

UnknownDRDOS:         MOV  DX, OFFSET UnknownDRDOS_Msg; output startup message
                      CALL DisplayError            ;
                      MOV  AX, 02FEh               ; errorlevel 254
                      Rtn                          ;

DRDOSok:              MOV  AX, WO ES:[BX+12h]      ; pointer to pre-environment segment
                      PUSH AX                      ; save away "ES"
                      CLD                          ;
                      MOV  AX, 352Fh               ; get 2Fh vector
                      INT  21h                     ;
                      PUSH ES                      ;
                      POP  AX                      ;
                      CMP  AX, 0                   ; zero?
                      POP  AX                      ; restored "ES" (pre-environment)
                      JNE  INT2FValid              ;
                      CMP  BX, 0                   ; zero?
                      JNE  INT2FValid              ;
                      CMP  AX, 0                   ; invalid 2Fh vector, so skip
                      JE   NotPreEnv               ; calls to INT2Fh
                      PUSH AX                      ; save "ES"
                      JMP  StartLoop               ; skip

CMDLoaded:            POP ES                       ; align stack
                      MOV  DX, OFFSET CMDLoaded_Msg;
                      CALL DisplayError            ;
                      MOV  AX, 02FCh               ; errorlevel 252
                      Rtn                          ;

INT2FValid:           PUSH AX                      ; save away "ES" again
                      PUSH CX                      ; also save CL
                                                   ;
                      MOV  AX, 0E000h              ; call to FREEVER
                      XOR  BX, BX                  ;
                      XOR  CX, CX                  ;
                      MOV  DX, 04D50h              ; "MP" FREEVER signature
                      INT  2Fh                     ; DX:DI -> signature
                      CMP  AL, 0FFh                ; installed?
                      JNE  TestSETDRVER            ;
                      CMP  CX, 0100h               ; correct version?
                      JB   TestSETDRVER            ;
                      CMP  DX, 04D50h              ; not changed?
                      JNE  SETDRVEROk              ;

TestSETDRVER:         MOV  AX, 0E000h              ; call to SETDRVER
                      XOR  BX, BX                  ;
                      XOR  CX, CX                  ;
                      XOR  DX, DX                  ;
                      INT  2Fh                     ;
                      CMP  AX, 4A52h               ; "JR" SETDRVER signature
                      JNE  SkipDRVER               ;

SETDRVEROk:           MOV  AX, 0E001h              ; get SETDRVER/FREEVER API level
                      XOR  BX, BX                  ;
                      XOR  CX, CX                  ;
                      INT  2Fh                     ;
                      CMP  AX, 020Ah               ; lowest supported level
                      JB   SkipDRVER               ;
                      MOV  AX, 0E002h              ;
                      XOR  BX, BX                  ;
                      XOR  CX, CX                  ;
                      XOR  DX, DX                  ;
                      INT  2Fh                     ;
                      CMP  DH, 06h                 ; at least DR DOS 6.0
                      JAE  SkipDRVER               ;
                      POP  CX                      ; align stack
                      POP  AX                      ;
                      JMP  WrongDOS                ; and exit

NotPreEnv:            MOV  DX, OFFSET NotPreEnv_Msg; output startup message
                      CALL DisplayError            ;
                      MOV  AX, 02FDh               ; errorlevel 253
                      Rtn                          ;

SkipDRVER:            POP  CX                      ; get back CX
                      CMP  CL, 72h                 ; was Novell DOS 7 or Caldera OpenDOS 7.01? (old CL)
                      JNE  NotNovellDOS            ;
                      MOV  AX, 5500h               ; COMMAND.COM loaded?
                      INT  2Fh                     ; (unsupported by Novell DOS and Caldera OpenDOS 7.01)
                      CMP  AX, 0                   ; yes -> no *pre*-environment
CMDLoaded2:           JE   CMDLoaded               ;
NotNovellDOS:         CALL TopViewInstalled        ;
                      JNZ  CMDLoaded               ;
                      MOV  AX, 0D44Dh              ; 4DOS.COM loaded?
                      MOV  BX, 0                   ;
                      INT  2Fh                     ;
                      CMP  AX, 44DDh               ;
                      JE   CMDLoaded2              ;
                      MOV  AX, 0E44Dh              ; NDOS.COM loaded?
                      MOV  BX, 0                   ;
                      INT  2Fh                     ;
                      CMP  AX, 44EEh               ;
                      JE   CMDLoaded2              ;

StartLoop:            POP  ES                      ; get "ES"
                      PUSH ES                      ;
                      POP  AX                      ;
                      CMP  AX, 0                   ; pre-environment not available?
                      JE   NotPreEnv               ;

                      MOV  DI, 0                   ;
EnvLoop:              CMP  WO ES:[DI], 0000h       ; scan for end of list
                      JE   EndFound                ;
                      CMP  DI, MaxEnvLen           ;
                      JAE  EnvFull                 ;
                      INC  DI                      ;
                      Jmps EnvLoop                 ;
                                                   ;
EndFound:             INC  DI                      ; ES:DI -> end word of list
                      INC  DI                      ;
                      CMP  WO ES:[DI], ID          ; ES:DI -> 1st byte beyond end
                      JNE  IDNotFound              ; ID beyond the end of list?

IDFound:              INC  DI                      ;
                      INC  DI                      ;
                      CMP  BY ES:[DI], 00h         ;
                      JE   EnvEmpty                ; empty -> nothing to do...
                      MOV  SI, DI                  ; store target position
                      MOV  CX, 2                   ; reset counter
EnvLoop2:             CMP  WO ES:[DI], 0000h       ;
                      JE   EndFound2               ;
                      CMP  DI, MaxEnvLen           ;
                      JAE  EnvFull                 ;
                      INC  DI                      ;
                      INC  CX                      ;
                      Jmps EnvLoop2                ;

EndFound2:            CLD                          ; count up
                      PUSH ES                      ;
                      POP  DS                      ; DS:SI -> source
                      MOV  DI, SI                  ;
                      SUB  DI, 4                   ;
                      REP  MOVSB                   ; copy source -> target
                      MOV  WO ES:[DI-2], 0000h     ;
                      MOV  WO ES:[DI], 0000h       ;
                      PUSH CS                      ;
                      POP  DS                      ;
                      MOV  DX, OFFSET Recovered_Msg;
                      Jmps Recovered               ;

EnvEmpty:             MOV  DX, OFFSET EnvEmpty_Msg ;
Recovered:            CALL DisplayMsg              ;
                      MOV  AX, 0201h               ; errorlevel 1
                      Rtn                          ;

EnvFull:              MOV  DX, OFFSET EnvFull_Msg  ;
                      CALL DisplayMsg              ;
                      MOV  AX, 02FBh               ; errorlevel 251
                      Rtn                          ;

IDNotFound:           CMP  WO ES:[DI], 0000h       ; test, if 4 bytes available?
                      JNE  EnvFull                 ;
                      INC  DI                      ;
                      INC  DI                      ;
                      CMP  WO ES:[DI], 0000h       ; ES:DI -> 3rd byte beyond end
                      JNE  EnvFull                 ;
                      INC  DI                      ; ES:DI -> 4th byte beyond end
                      CMP  DI, MaxEnvLen           ;
                      JAE  EnvFull                 ;
                      MOV  SI, DI                  ; store target position
                      PUSH ES                      ;
                      POP  DS                      ; DS:SI is target
                      STD                          ; count down
                      SUB  SI, 4                   ; DS:SI -> source
                      MOV  CX, SI                  ;
                      INC  CX                      ;
                      REP  MOVSB                   ; copy source -> target
                      INC  SI                      ;
                      MOV  WO ES:[SI], 0000h       ;
                      MOV  WO ES:[SI+2], ID        ;
                      PUSH CS                      ;
                      POP  DS                      ;
                      MOV  DX, OFFSET Hidden_Msg   ;
                      CALL DisplayMsg              ;
                      MOV  AX, 0202h               ; errorlevel 2
                      Rtn                          ;

                      ; #######################################################

BreakOut:             MOV  DX, OFFSET BreakOut_Msg ; output breakout message
                      CALL DisplayHint             ;
                      MOV  DX, OFFSET Wait_Msg     ; display temporary message
                      CALL DisplayMsg              ;
Wait4Release:         INT  28h                     ; signal idle loop (DOS 2.0+)
                      CALL CheckBreakOut           ;
                      JAE  Wait4Release            ;
                      MOV  DX, OFFSET Finished_Msg ; delete temporary message
                      CALL DisplayMsg              ;
                      ; <insert an one second delay here>
                      MOV  AX, 02FAh               ; errorlevel
                      Rtn                          ;

                      ; #######################################################

CheckBreakOut:                                     ; destroys AX
                      MOV  AX, 0200h               ; get BIOS keyboard flags
                      INT  16h                     ; 0040h:0017h in AL
                      AND  AL, 0Fh                 ; <Shift>+<Ctrl>+<Alt>
                      CMP  AL, 0Dh                 ; emergency hotkey pressed?
                      Rtn                          ;

                      ; #######################################################

CheckANSI:            MOV  DX, OFFSET LeadIn_Msg   ; output startup message
                      CALL DisplayMsg              ;

                      MOV  AX, 4400h               ; DOS function "Get device attributes"
                      MOV  BX, 1                   ; Handle 1 (standard output)
                      INT  21h                     ;
                      AND  DL, 82h                 ;
                      CMP  DL, 82h                 ; DEVICE/FILE & StdOut bits
                      JE   ANSIStart               ; if redirected, then exit:
                      Rtn                          ; ANSI=off -> JNE
                                                   ;
ANSIStart:            CALL StartCriticalSection    ;
                      PUSH BP                      ;
                      CLI                          ; Do not disturb (if possible...)
                      MOV  AX, 0F03h               ; Get current video mode
                      XOR  BX, BX                  ; to select from other Non-BIOS providers
                      XOR  SI, SI                  ;
                      INT  10h                     ; Call video BIOS: BH = current page
                      MOV  AX, 0300h               ; Get cursor position & size (in page BH)
                      INT  10h                     ; Call video BIOS: DH = row, DL = column
                      PUSH DX                      ; Store
                      MOV  DX, OFFSET ANSILeadIn_Msg;
                      CALL DisplayMsg              ; DS:DX
                      MOV  AX, 0300h               ; Again, get cursor position & size
                      INT  10h                     ;          DL = new column value
                      POP  CX                      ; Restore: CL = old column value
                      PUSH CX                      ; Store again
                      INC  CX                      ; Align old position to expected position
                      CMP  DL, CL                  ; Has ANSI moved the cursor?
                      JE   ANSIFound               ; Yes: ok, ANSI is active
                      PUSHF                        ; Store flags
                      MOV  DX, OFFSET ANSILeadOut_Msg; ANSI not active (or remote session)
                      CALL DisplayMsg              ;
                      POPF                         ; Restore flags
ANSIFound:            POP  DX                      ; Restore old cursor position in DX
                      PUSHF                        ; Store flags
                      MOV  AX, 0200h               ; DX=pos, BH=page
                      INT  10h                     ;
                      POPF                         ; Restore flags
                      STI                          ;
                      POP  BP                      ;
                      CALL EndCriticalSection      ;
                      JZ   ANSIEnd                 ; JZ for ANSI=on -> JE
                                                   ;
                      CALL CheckINT2FValid         ;
                      JZ   ANSIZero                ; ANSI=off -> convert JZ in JNE
                                                   ;
                      MOV  AX, 1A00h               ; Installation check for ANSI driver
                      MOV  BX, 0000h               ; to select from other version checks
                      INT  2Fh                     ; (Works for ANSIPLUS & AVATAR, too,
ANSIZero:             CMP  AL, 0FFh                ; but not for EANSI and other clones.)
ANSIEnd:              Rtn                          ;

                      ; #######################################################

TopViewInstalled:     ; AX, BX, FLAGS destroyed    ;
                      MOV  AX, 1022h               ; test for TopView/DESQView
                      XOR  BX, BX                  ;
                      INT  15h                     ;
                      CMP  BX, 0                   ;
                      Rtn                          ; JZ if not installed

CheckINT2FValid:      ; destroys AX, BX, ES, FLAGS ;
                      CLD                          ;
                      MOV  AX, 352Fh               ; get 2Fh vector
                      INT  21h                     ;
                      PUSH ES                      ;
                      POP  AX                      ;
                      OR   AX, BX                  ; is ES:BX nonzero?
                      Rtn                          ; JZ if not defined

                      ; #######################################################

StartCriticalSection: ; destroys AX, BX, ES        ;
                      PUSHF                        ;
                      CALL TopViewInstalled        ;
                      JZ   SkipTVStartCS           ;
                      MOV  AX, 101Bh               ; Quarterdesk's DESQview(/X) / IBM's TopView /
                      INT  15h                     ; Sunny Hill Software's TaskView/OmniView
                                                   ;
SkipTVStartCS:        CALL CheckINT2FValid         ;
                      JZ   SkipStartCS             ;
                      MOV  AX, 1681h               ; MS Windows
                      INT  2Fh                     ;
                      ;MOV AX, 4003h               ; exit within one second!!!
                      ;INT 2Fh
SkipStartCS:          POPF                         ;
                      Rtn                          ;

EndCriticalSection:   ; destroys AX, BX, ES        ;
                      PUSHF                        ;
                      CALL CheckINT2FValid         ;
                      JZ   Skip2FEndCS             ;
                      ;MOV AX, 4004h               ;
                      ;INT 2Fh                     ;
                      MOV  AX, 1682h               ;
                      INT  2Fh                     ;
                                                   ;
Skip2FEndCS:          CALL TopViewInstalled        ;
                      JZ   SkipTVEndCS             ;
                      MOV  AX, 101Ch               ; DESQview/TopView/TaskView/OmniView
                      INT  15h                     ;
SkipTVEndCS:          POPF                         ;
                      Rtn                          ;

                      ; #######################################################

DisplayTitle:         PUSH DX                      ; destroys DX
                      MOV  DX, OFFSET ANSIYellow_Msg
                      CALL DisplayANSISeq          ;
                      Jmps DisplayANSIEnd          ;

DisplayError:         PUSH DX                      ; destroys DX
                      MOV  DX, OFFSET ANSILightRed_Msg
                      CALL DisplayANSISeq          ;
                      Jmps DisplayANSIEnd          ;

DisplayHint:          PUSH DX                      ; destroys DX
                      MOV  DX, OFFSET ANSIWhite_Msg;
                      CALL DisplayANSISeq          ;

DisplayANSIEnd:       POP  DX                      ;
                      CALL DisplayMsg              ;
                      MOV  DX, OFFSET ANSINorm_Msg ;

DisplayANSISeq:       Rtn                          ; NOPed if ANSI driver

DisplayMsg:           PUSH AX                      ;
                      MOV  AH, 09h                 ;
                      INT  21h                     ;
                      POP  AX                      ;
                      Rtn                          ;

                      ; #######################################################

ANSILeadIn_Msg        DB ESC_, "[C", LTERM
ANSILeadOut_Msg       DB BS, BS, BS, BS, "    ", BS, BS, BS, BS, LTERM
ANSIYellow_Msg        DB ESC_, "[", ANSINorm, ";", ANSIHigh, ANSIBrown, ";", ANSIBlackH, "m", CR, LTERM
ANSILightRed_Msg      DB ESC_, "[", ANSINorm, ";", ANSIHigh, ANSIRed, ";", ANSIBlackH, "m", CR, LTERM
ANSIWhite_Msg         DB ESC_, "[", ANSINorm, ";", ANSIHigh, ANSIWhite, ";", ANSIBlackH, "m", CR, LTERM
ANSINorm_Msg          DB "    ", ESC_, "[", ANSINorm, "m", BS, BS, BS, BS, "    ", CR, LTERM

LeadIn_Msg            DB CR, LF, LTERM
Title_Msg             DB "SETENV V", Version_Msg, " Copyright (C) 1996-1997 by Matthias Paul", CR, LF, LTERM
Startup_Msg           DB "Utility to hide DR DOS 6.0, Novell DOS 7, Caldera OpenDOS pre-environment.", CR, LF, LTERM
WrongDOS_Msg          DB "  Error: Sorry, but DR DOS 6.0, Novell DOS 7, or Caldera OpenDOS required.", CR, LF, LTERM
UnknownDRDOS_Msg      DB "  Error: Unknown single-user DR DOS, Novell DOS, or Caldera OpenDOS version,", CR, LF
                      DB "         or unsupported DR/CCI/IMS Multiuser DOS or IMS REAL/32 version!", CR, LF
                      DB "         Please report this to me for enabling support. Thanks.", CR ,LF, LTERM
UntestedDRDOS_Msg     DB "  Warning: Currently DR PalmDOS is untested to run SETENV!", CR, LF
                      DB "           Please report your results to add better support in the future.", CR, LF, LTERM
CMDLoaded_Msg         DB "  Error: Command processor (COMMAND.COM, 4DOS.COM, NDOS.COM) already loaded.", CR, LF, LTERM
NotPreEnv_Msg         DB "  Error: CONFIG.SYS pre-environment not available any more.", CR, LF
                      DB "         Usage of COMMAND.COM normally closes the pre-environment.", CR, LF, LTERM
EnvFull_Msg           DB "  Error: CONFIG.SYS pre-environment full.", CR, LF, LTERM
EnvEmpty_Msg          DB "  Error: CONFIG.SYS pre-environment empty.", CR, LF, LTERM
Hidden_Msg            DB "  CONFIG.SYS pre-environment has now been hidden.", CR, LF, LTERM
Recovered_Msg         DB "  CONFIG.SYS pre-environment has now been recovered.", CR, LF, LTERM
BreakOut_Msg          DB "  Break signaled by <Shift>+<Ctrl>+<Alt>. SETENV will be skipped.", CR, LF, LTERM
Wait_Msg              DB "  To continue, release emergency breakout hotkey, please...", LTERM
Finished_Msg          DB 59 DUP (BS)
                      DB 59 DUP (SPACE)
                      DB 59 DUP (BS)
                      DB LTERM

Code ENDS
END SETENV
